/*
 * MUI_main.c
 *
 */

#include <string.h>
#include "MUI_bluetooth.h"
#include "MUI_configuration.h"
#include "MUI_log.h"
#include "MUI_pressure_sensor.h"
#include "MUI_reader.h"
#include "MUI_timer.h"

void monitorPressure(void)
{
 MUIpsGetMeasure();
 MUIlogInformation(1);
 MUIlogError("Monitoring");
 return;
}


void checkReaderCommand(void)
{
 MUIrdDetect();
 MUIrdConnect();
 MUIrdProcessCommand();
}


void startMonitoring(void)
{
  int index=0;
  MUIconfRead();
  MUIresetTimer();
  MUIpsCalibrate();
  MUIpsSetAccuracy();
  MUIpsSelfcheck();
  MUIrdConfigure();
  MUIlogInformation(2);
  MUIsetTimer();
  while (index<4)
  {
	  monitorPressure();
	  MUIpsDetectLeak();
	  checkReaderCommand();
	  MUIwakeUp();
	  index++;
  }
}

int main(void)
{
  MUIbtReset();
  MUIlogInformation(3);
  startMonitoring();
  return(0);
}


