/*
 *  Licensed Materials - Property of IBM / HCL Technologies
 *  Restricted Material of IBM / HCL Technologies
 *  IBM Rational Test RealTime / HCL OneTest
 *  (c) Copyright IBM Corp. 2020 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 *       |\      _,,,---,,_
 *       /,`.-'`'    -.  ;-;;,_
 *      |,4-  ) )-,_..;\ (  `'-'
 *     '---''(_/--'  `-'\_)
 *
 ********************************************
 */
/*
 * this file contains main playing loop.
 * a bit basic but no multithread to ease port on various platforms
 */
#include <stdio.h>
#if 0
/* a try to use ncurses to get char without the need to type enter after */
#ifdef WIN32
#include <conio.h>
#else /* WIN32 */
#include <ncurses.h>
#endif /* WIN32 */
#endif /* 0 */
#include "core.h"
#include "game.h"
#include "display.h"

int currentX = 0;
int currentY = 0;


static int win() {
	return (currentY == size_y-1);
}

void play(void) {
	char c;
	int changepos;
	int dir;
	int bump = 0;
	int moves[1024]; /* todo : dynamic buffer that increase over use*/
	int nbmove = 0;
	int startx;
	int starty;

	currentX = 1+myrandom(size_x-3);
	currentY = 1;
	startx = currentX;
	starty = currentY;

#pragma attol cov_justify ("logical","/while/0","Never win by default")
	while (!win()) {
		changepos = 0;
		displayMatrixAndPos(currentX,currentY,0,'X');
		displayGameHelp();
		displayGamePrompt(bump);
		fflush( stdout );
//		c = getch();
		c = fgetc(stdin);
		dir = -1;
		switch(c) {
			case '8' :
				dir = UP;
				break;
			case '6' :
				dir = RIGHT;
				break;
			case '2' :
				dir = DOWN;
				break;
			case '4' :
				dir = LEFT;
				break;
			case 'q' :
				displayQuit();
				return;
			default :
				break;
		}
		if (dir != -1) {
			if (havewall(currentX,currentY,dir)) {
				bump = 1;
			} else {
				bump = 0;
				changepos = 1;
			}
		}
		if (changepos) {
			currentX += offset_x[dir];
			currentY += offset_y[dir];
			if (nbmove < 1024) {
				moves[nbmove] = dir;
			}
			nbmove++;
		}
	}
	displayEnd(nbmove,startx,starty,moves);
}

